;;;  This file contains some simple functions for providing the
;;;  user with access to a counter, for use in keyboard macros and
;;;  the like.
;;;
;;;  ESC := sets the counter to its argument, or 1
;;;  ESC + increments the counter by its argument, or 1
;;;  ESC * inserts counter value, and if no argument, increments it

;;;  The counter is called, imaginatively, "user-counter"

(defvar user-counter 1 "*Scratch counter for user while writing")

(make-variable-buffer-local 'user-counter)


(defun user-counter-set (initial) 
   "Set the user-counter to the argument value (default 1)"
  (interactive "p")
  (setq user-counter initial))

(defun user-counter-increment (inc)
   "Increments the user-counter by teh argument value, if given, or 1"
  (interactive "p")
  (setq user-counter (+ user-counter inc)))

(defun user-counter-insert (no-increment)
  (interactive "*P")
  (insert (format "%d" user-counter))
  (if (not no-increment)
      (user-counter-increment 1)))

(define-key global-map [C-f1] 'user-counter-insert)
