;; Extended execute
;;
;; Allow M-x to also do goto-line and evaluate general lisp expressions
;;

(defun extended-execute (str)
  (interactive "sM-x: ")
  (let ((sym (intern-soft str)))
    (cond
     ((and sym (commandp sym t))	
      ; if the string is the name of a command, execute it
      (call-interactively sym))	
     ((string-match "^[0-9]+$" str)
      ; if the string is a number, goto that line
      (goto-char (point-min)) 
      (forward-line (1- (string-to-int str))))
     (t
      ; Assume the string is a lisp expression and evaluate it
      (eval-expression (read str))))))

 (substitute-key-definition
  'execute-extended-command 'extended-execute (current-global-map))



(provide 'extended-execute);