#! /usr/bin/awk -f
#
# Name:		fa-adint.awk
# Usage:	fa-adint.awk files . . . >advised-file.el
# Description:  Produce a set of advice for interactive functions 
#		to allow them to peacefully coexist with frame-assoc.el
# Version:	%id%
# History:
#   02-Nov-1996	M Munro
#		Original version.

BEGIN	{
	# Print a heading for the advice file, saying when, where and
	# by whom and what it was built.

	print ";; Advice file to allow the following interactive functions"
	print ";; to peacefully coexist with frame-assoc.el (the frame"
	print ";; association package).  This emacs lisp file was produced"
	printf (";; automatically by fa-adint.awk on ")
	system("date")
	printf (";; on host ")
	system ("hostname")
	printf ";;\n\n"
}
/^[ \t]*\(defun/	{
	# This is a function definition line.  Record it, so that we can
	# generate advice for it later.
	function_name = $2
	# Ensure that we only pick up the name and not any parameters as
	# well.
	sub(/\(.*/, "", function_name)
}
/^[ \t]*\(interactive[) ]/	{
	# This is the interactive definition for the current function.
	# That means we must generate advice for the function.

	print "(defadvice " function_name "(around vm-frame-assoc first)"
	print "  \"Advised to allow  peaceful coexistence with frame-assoc."
	print "This advice has been automatically generated by fa-adint.awk\""
	print "  (let ((fa-defer-operations t))"
	print "    ad-do-it)"
	print "  (fa-perform-deferred))"
	print ""
}
