;;**********************************************************************;;
;;									;;
;;	Marc Munro					Jul 92		;;
;;									;;
;;	Hacked version of the grep command.  This allows the output	;;
;;	from grep to be piped through filters such as grep, tail, etc	;;
;;	before being placed into the compilation buffer.  It works	;;
;;	exactly like the standard grep apart from allowing pipes in	;;
;;	the command line.						;;
;;									;;
;;	To use this version, just autoload it by adding the following	;;
;;	line to your .emacs file:					;;
;;									;;
;;	(autoload 'grep "hack-grep")					;;
;;									;;
;;									;;
;;**********************************************************************;;

(require 'compile)

(defun grep (command-args)
  "Run grep, with user-specified args, and collect output in a buffer.
While grep runs asynchronously, you can use the \\[next-error] command
to find the text that grep hits refer to.

This command uses a special history list for its arguments, so you can
easily repeat a grep command.

This is marc's hacked version which allows pipes to be used in the grep
command line."
  (interactive
   (list (read-from-minibuffer "Run grep (like this): "
			       "grep -n " nil nil 'grep-history)))
  (let (index)
    (if (setq index (string-match "|" command-args))
	(setq command-args (concat (substring command-args 0 index)
			      " /dev/null "
			      (substring command-args index 
					 (length command-args))))
      (setq command-args (concat command-args " /dev/null"))))
  (compile-internal command-args
		    "No more grep hits" "grep"
		    ;; Give it a simpler regexp to match.
		    nil grep-regexp-alist))

(provide 'hack-grep)
