;; Lisp to deal with different aspects of functions in different modes.

(defadvice forward-sentence (around mode-stuff first activate)
  "If in lisp or c-mode, move forward by sexp rather than sentence."
  (if (or (eq major-mode 'emacs-lisp-mode)
	  (eq major-mode 'lisp-mode)
	  (eq major-mode 'c-mode)
	  (eq major-mode 'elec-c-mode))
      (call-interactively 'forward-sexp)
    ad-do-it))

(defadvice backward-sentence (around mode-stuff first activate)
  "If in lisp or c-mode, move backward by sexp rather than sentence."
  (if (or (eq major-mode 'emacs-lisp-mode)
	  (eq major-mode 'lisp-mode)
	  (eq major-mode 'c-mode)
	  (eq major-mode 'elec-c-mode))
      (call-interactively 'backward-sexp)
    ad-do-it))

(defadvice forward-paragraph (around mode-stuff first activate)
  "If in lisp or c-mode move by defun, else move by paragraph."
  (if (or (eq major-mode 'emacs-lisp-mode)
	  (eq major-mode 'lisp-mode)
	  (eq major-mode 'c-mode)
	  (eq major-mode 'elec-c-mode))
      (call-interactively 'end-of-defun)
    ad-do-it))

(defadvice backward-paragraph (around mode-stuff first activate)
  "If in lisp or c-mode move by defun, else move by paragraph."
  (if (or (eq major-mode 'emacs-lisp-mode)
	  (eq major-mode 'lisp-mode)
	  (eq major-mode 'c-mode)
	  (eq major-mode 'elec-c-mode))
      (call-interactively 'beginning-of-defun)
    ad-do-it))
