;;**********************************************************************;;
;;									;;
;;		E m a c s   O d d   N a r r o w i n g  			;;
;;		-------------------------------------  			;;
;;									;;
;;	Marc Munro					Dec 91		;;
;;									;;
;;	Function to toggle between narrowed and non-narrowed state.     ;;
;;									;;
;;	Provided as feature narrow-toggle.				;;
;;									;;
;;	Share and Enjoy.						;;
;;									;;
;;**********************************************************************;;

(defvar narrowed nil
  "Default non-local variable used to identify unnarrowed buffers.")

(defun narrow-widen ()
  "Toggle between narrowed and non-narrowed state.
Creates a local variable narrowed which is given the value t when narrowed, 
and kills thee local variable rendering the default (with value nil) visible
again."
  (interactive)
  (if (not narrowed)
    (progn
      (make-local-variable 'narrowed)
      (setq narrowed t)
      (narrow-to-region (mark) (point))
    )
    (progn
      (kill-local-variable 'narrowed)
      (widen)
    )
  )
)

(provide 'narrow-toggle)
