;;**********************************************************************;;
;;									;;
;;		E m a c s   O d d   M o v e s				;;
;;		-----------------------------   			;;
;;									;;
;;	Marc Munro					Dec 91		;;
;;									;;
;;	This provides additional cursor movement functions for moving 	;;
;;	to the next end of line and previous start of line.  Both of	;;
;;	these functions may take a numeric argument, and use it in the	;;
;;	obvious manner.							;;
;;	They are provided as the odd-moves feature using provide.	;;
;;									;;
;;	Share and enjoy.						;;
;;									;;
;;**********************************************************************;;


(defun next-end-of-line (n)
  "Moves point to the end of the current line, or if already there, to the
 end of the next one.  Takes a numeric argument as may be provided by
 universal argument."
  (interactive "p")
  (if (= n 1)
      (forward-char 1)
    (next-line n))
  (end-of-line)
)

(defun prev-start-of-line (n)
  "Moves point to the start of the current line, or if already there, to the
start of the previous one.  Takes a numeric argument as may be provided by
 universal argument."
  (interactive "p")
  (if (= n 1)
      (backward-char 1)
    (previous-line n))
  (beginning-of-line)   
)

(provide 'odd-moves)


