(defvar plsql-block-words 
  "\\(declare\\|begin\\|exception\\|end;\\)"
  "PL/SQL Block delimiting words.")

(defun plsql-in-comment-p ()
  "Test function."
  nil)

(defun plsql-in-string-p ()
  nil)

(defun plsql-prev-block-word (arg)
  "Function to skip to previous PL/SQL block delimiter word."
  (interactive "p")
  (cond ((< arg 0)
	 (plsql-next-block-word (* -1 arg)))
	((= arg 0)
	 nil)
	(t
	 (while (> arg 0)
	   (re-search-backward plsql-block-words nil t)
	   (if (not (or (plsql-in-string-p)
			(plsql-in-comment-p)))
	       (setq arg (1- arg)))))))

(defun plsql-next-block-word (arg)
  "Function to skip to previous PL/SQL block delimiter word."
  (interactive "p")
  (cond ((< arg 0)
	 (plsql-prev-block-word (* -1 arg)))
	((= arg 0)
	 nil)
	(t
	 (while (> arg 0)
	   (re-search-forward plsql-block-words nil t)
	   (if (not (or (plsql-in-string-p)
			(plsql-in-comment-p)))
	       (setq arg (1- arg)))))))

(defun plsql-check-level (level)
  "Hmmm."
  (cond ((looking-at "declare")
	 level)
	((looking-at "begin")
	 (1- level))
	((looking-at "exception")
	 level)
	((looking-at "end")
	 (1+ level))
	(t 0)))

(defun plsql-back-block ()
  

(defun plsql-backward-block ()
  (interactive)
  (if (not (looking-at plsql-block-words))
      (plsql-next-block-word 1))
  ;; Now we want to go back to a previous word at the same level.

  (if (> (plsql-prev-block-word 1) 0)
      xxxxxxx
  


(defun plsql-back-block (level)
  "Function to move to beginning of current PL/SQL block."
  (interactive)
  (plsql-prev-block-word 1)
  (plsql-check-level level))

(defun plsql-backward-block ()
  (interactive)
  (if (not (looking-at plsql-block-words))
      (plsql-next-block-word 1))
  (let ((level 0))
    (while (<= 0 (setq level (plsql-back-block level))))))
  
(defun plsql-forward-block ()
  "Function to move to end of current PL/SQL block."
  (interactive))
  


(defvar plsexp-sexp-list
  nil
  "Variable identifying programming language sexp definitions for the 
current buffer.  It looks like this:

sexp-list         ::= sexp-regexp sexp-details-list.
sexp-regexp       ::= <a regular expression of all of the syntax elements 
                       of the programming language sexp set>.
sexp-details-list ::= '(' sexp-details {sexp-details} ')'.
sexp-details      ::= '(' syntax-elem mandatory ?????
mandatory         ::= 'nil'|'t'.
syntax-elem       ::= <string identifying the element (eg "IF", "THEN" etc)>.



This variable should be buffer local.

(defun plsexp-add-sexp (sexp)
  "Add a programming language sexp definition to the plsexp sexp list."
  (interactive)  ;; for now.
  )





